Index: code/branches/main_reto_vs05/src/ammunition_dump.cc
===================================================================
--- code/branches/main_reto_vs05/src/ammunition_dump.cc	(revision 161)
+++ code/branches/main_reto_vs05/src/ammunition_dump.cc	(revision 169)
@@ -29,5 +29,5 @@
 
 
-namespace Orxonox {
+namespace orxonox {
 
   AmmunitionDump::AmmunitionDump()
Index: code/branches/main_reto_vs05/src/ammunition_dump.h
===================================================================
--- code/branches/main_reto_vs05/src/ammunition_dump.h	(revision 169)
+++ code/branches/main_reto_vs05/src/ammunition_dump.h	(revision 169)
@@ -0,0 +1,53 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software: you can redistribute it and/or modify
+ *   it under the terms of the GNU General Public License as published by
+ *   the Free Software Foundation, either version 3 of the License, or
+ *   (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ *
+ *
+ *   Author:
+ *      Reto Grieder
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+
+#ifndef AmmunitionDump_H
+#define AmmunitionDump_H
+
+#include "OgrePrerequisites.h"
+
+#include "orxonox_prerequisites.h"
+
+
+namespace orxonox {
+
+  class AmmunitionDump
+  {
+  public:
+	  AmmunitionDump();
+	  ~AmmunitionDump();
+
+  protected:
+
+  protected:
+
+  };
+
+}
+
+#endif /* AmmunitionDump_H */
Index: code/branches/main_reto_vs05/src/barrel_gun.cc
===================================================================
--- code/branches/main_reto_vs05/src/barrel_gun.cc	(revision 169)
+++ code/branches/main_reto_vs05/src/barrel_gun.cc	(revision 169)
@@ -0,0 +1,46 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software: you can redistribute it and/or modify
+ *   it under the terms of the GNU General Public License as published by
+ *   the Free Software Foundation, either version 3 of the License, or
+ *   (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ *
+ *
+ *   Author:
+ *      Reto Grieder
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#include "OgreSceneManager.h"
+
+#include "barrel_gun.h"
+
+
+namespace orxonox {
+  using namespace Ogre;
+
+  BarrelGun::BarrelGun(SceneManager *sceneMgr) : sceneMgr_(sceneMgr)
+  {
+  	
+  }
+
+
+  BarrelGun::~BarrelGun()
+  {
+  }
+
+}
Index: code/branches/main_reto_vs05/src/barrel_gun.h
===================================================================
--- code/branches/main_reto_vs05/src/barrel_gun.h	(revision 169)
+++ code/branches/main_reto_vs05/src/barrel_gun.h	(revision 169)
@@ -0,0 +1,57 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software: you can redistribute it and/or modify
+ *   it under the terms of the GNU General Public License as published by
+ *   the Free Software Foundation, either version 3 of the License, or
+ *   (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ *
+ *
+ *   Author:
+ *      Reto Grieder
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+
+#ifndef BARREL_GUN_H
+#define BARREL_GUN_H
+
+#include "OgrePrerequisites.h"
+
+#include "orxonox_prerequisites.h"
+
+
+namespace orxonox {
+
+  class BarrelGun
+  {
+  public:
+    BarrelGun(Ogre::SceneManager*);
+	  virtual ~BarrelGun();
+
+  protected:
+
+  public:
+    Ogre::SceneManager *sceneMgr_;
+	  Ogre::Entity *weaponEntity_;
+
+  protected:
+
+  };
+
+}
+
+#endif /* BARREL_GUN_H */
Index: code/branches/main_reto_vs05/src/bullet.cc
===================================================================
--- code/branches/main_reto_vs05/src/bullet.cc	(revision 161)
+++ code/branches/main_reto_vs05/src/bullet.cc	(revision 169)
@@ -33,11 +33,11 @@
 
 
-namespace Orxonox {
+namespace orxonox {
   using namespace Ogre;
 
-  Bullet::Bullet(SceneNode *mNode, Entity *mEntity, Vector3 mSpeed)
-        : mNode(mNode), mEntity(mEntity), mSpeed(mSpeed)
+  Bullet::Bullet(SceneNode *node, Entity *entity, Vector3 speed)
+    : node_(node), entity_(entity), speed_(speed)
   {
-	  mNode->attachObject(mEntity);
+	  node_->attachObject(entity_);
   }
 
Index: code/branches/main_reto_vs05/src/bullet.h
===================================================================
--- code/branches/main_reto_vs05/src/bullet.h	(revision 169)
+++ code/branches/main_reto_vs05/src/bullet.h	(revision 169)
@@ -0,0 +1,58 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software: you can redistribute it and/or modify
+ *   it under the terms of the GNU General Public License as published by
+ *   the Free Software Foundation, either version 3 of the License, or
+ *   (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ *
+ *
+ *   Author:
+ *      Reto Grieder
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+
+#ifndef BULLET_H
+#define BULLET_H
+
+#include "OgrePrerequisites.h"
+
+#include "orxonox_prerequisites.h"
+
+
+namespace orxonox {
+
+  class Bullet
+  {
+  public:
+	  Bullet(Ogre::SceneNode*, Ogre::Entity*, Ogre::Vector3);
+	  ~Bullet();
+
+  protected:
+
+  public:
+    Ogre::SceneNode *node_;
+	  Ogre::Entity *entity_;
+	  Ogre::Vector3 speed_;
+
+  protected:
+
+  };
+
+}
+
+#endif /* BULLET_H */
Index: code/branches/main_reto_vs05/src/camera_manager.cc
===================================================================
--- code/branches/main_reto_vs05/src/camera_manager.cc	(revision 161)
+++ code/branches/main_reto_vs05/src/camera_manager.cc	(revision 169)
@@ -31,5 +31,5 @@
 #include "camera_manager.h"
 
-namespace Orxonox {
+namespace orxonox {
   using namespace Ogre;
 
Index: code/branches/main_reto_vs05/src/camera_manager.h
===================================================================
--- code/branches/main_reto_vs05/src/camera_manager.h	(revision 169)
+++ code/branches/main_reto_vs05/src/camera_manager.h	(revision 169)
@@ -0,0 +1,54 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software: you can redistribute it and/or modify
+ *   it under the terms of the GNU General Public License as published by
+ *   the Free Software Foundation, either version 3 of the License, or
+ *   (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ *
+ *
+ *   Author:
+ *      Reto Grieder
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+
+#ifndef CAMERA_MANAGER_H
+#define CAMERA_MANAGER_H
+
+#include "OgrePrerequisites.h"
+
+#include "orxonox_prerequisites.h"
+
+
+namespace orxonox {
+
+  class CameraManager
+  {
+  public:
+    CameraManager(Ogre::SceneManager*);
+	  ~CameraManager();
+
+	  bool setCameraPosition(int);
+
+  protected:
+	  Ogre::SceneManager *mSceneMgr;
+	  Ogre::Camera *mCamera;
+  };
+
+}
+
+#endif /* CAMERA_MANAGER_H */
Index: code/branches/main_reto_vs05/src/main.cc
===================================================================
--- code/branches/main_reto_vs05/src/main.cc	(revision 161)
+++ code/branches/main_reto_vs05/src/main.cc	(revision 169)
@@ -45,5 +45,5 @@
     try {
       // create an orxonox aplication and run it
-      Orxonox::Orxonox myApp;
+      orxonox::Orxonox myApp;
 
       myApp.go();
Index: code/branches/main_reto_vs05/src/ogre_control.cc
===================================================================
--- code/branches/main_reto_vs05/src/ogre_control.cc	(revision 161)
+++ code/branches/main_reto_vs05/src/ogre_control.cc	(revision 169)
@@ -39,5 +39,5 @@
 
 
-namespace Orxonox {
+namespace orxonox {
   using namespace Ogre;
 
Index: code/branches/main_reto_vs05/src/ogre_control.h
===================================================================
--- code/branches/main_reto_vs05/src/ogre_control.h	(revision 169)
+++ code/branches/main_reto_vs05/src/ogre_control.h	(revision 169)
@@ -0,0 +1,71 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software: you can redistribute it and/or modify
+ *   it under the terms of the GNU General Public License as published by
+ *   the Free Software Foundation, either version 3 of the License, or
+ *   (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ *
+ *
+ *   Author:
+ *      Reto Grieder
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+
+#ifndef OGRE_CONTROL_H
+#define OGRE_CONTROL_H
+
+#include "OgrePrerequisites.h"
+
+#include "orxonox_prerequisites.h"
+
+
+namespace orxonox {
+
+  class OgreControl
+  {
+  public:
+	  OgreControl();
+
+	  virtual ~OgreControl();
+
+	  /** Sets up the application - returns false if the user chooses to abandon configuration. */
+	  virtual bool initialise();
+
+    virtual Ogre::Root* getRoot();
+
+	  virtual Ogre::RenderWindow* getRenderWindow();
+
+	  virtual Ogre::String getResourcePath();
+
+  protected:
+	  /** Configures the application - returns false if the user chooses to abandon configuration. */
+	  virtual bool configure(void);
+
+	  /// Method which will define the source of resources (other than current folder)
+	  virtual void setupResources(void);
+
+  protected:
+	  Ogre::Root         *root_;
+	  Ogre::RenderWindow *window_;
+	  Ogre::String  resourcePath_;
+
+  };
+
+}
+
+#endif /* OGRE_CONTROL_H */
Index: code/branches/main_reto_vs05/src/orxonox.cc
===================================================================
--- code/branches/main_reto_vs05/src/orxonox.cc	(revision 161)
+++ code/branches/main_reto_vs05/src/orxonox.cc	(revision 169)
@@ -41,5 +41,5 @@
 
 
-namespace Orxonox {
+namespace orxonox {
 
   /**
Index: code/branches/main_reto_vs05/src/orxonox.h
===================================================================
--- code/branches/main_reto_vs05/src/orxonox.h	(revision 169)
+++ code/branches/main_reto_vs05/src/orxonox.h	(revision 169)
@@ -0,0 +1,59 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software: you can redistribute it and/or modify
+ *   it under the terms of the GNU General Public License as published by
+ *   the Free Software Foundation, either version 3 of the License, or
+ *   (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ *
+ *
+ *   Author:
+ *      Reto Grieder
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+
+#ifndef ORXONOX_H
+#define ORXONOX_H
+
+#include "OgrePrerequisites.h"
+
+#include "orxonox_prerequisites.h"
+
+namespace orxonox {
+
+  class Orxonox
+  {
+  public:
+    Orxonox();
+    virtual ~Orxonox();
+	  virtual void go();
+
+  protected:
+	  virtual bool setup(void);
+
+	  virtual void destroy(void);
+
+  protected:
+	  OgreControl *ogre_;
+	  RunManager  *runMgr_;
+	  Ogre::Timer *timer_;
+
+  };
+
+}
+
+#endif /* ORXONOX_H */
Index: code/branches/main_reto_vs05/src/orxonox_prerequisites.h
===================================================================
--- code/branches/main_reto_vs05/src/orxonox_prerequisites.h	(revision 169)
+++ code/branches/main_reto_vs05/src/orxonox_prerequisites.h	(revision 169)
@@ -0,0 +1,47 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software: you can redistribute it and/or modify
+ *   it under the terms of the GNU General Public License as published by
+ *   the Free Software Foundation, either version 3 of the License, or
+ *   (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ *
+ *
+ *   Author:
+ *      Reto Grieder
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+
+#ifndef ORXONOX_PREREQUISITES_H
+#define ORXONOX_PREREQUISITES_H
+
+namespace orxonox {
+
+  class AmmunitionDump;
+  class Bullet;
+  class CameraManager;
+  class OgreControl;
+  class Orxonox;
+  class OrxonoxShip;
+  class OrxonoxScene;
+  class RunManager;
+  class Weapon;
+  class WeaponManager;
+
+}
+
+#endif /* ORXONOX_PREREQUISITES_H */
Index: code/branches/main_reto_vs05/src/orxonox_scene.cc
===================================================================
--- code/branches/main_reto_vs05/src/orxonox_scene.cc	(revision 161)
+++ code/branches/main_reto_vs05/src/orxonox_scene.cc	(revision 169)
@@ -36,5 +36,5 @@
 #include "orxonox_scene.h"
 
-namespace Orxonox {
+namespace orxonox {
   using namespace Ogre;
 
Index: code/branches/main_reto_vs05/src/orxonox_scene.h
===================================================================
--- code/branches/main_reto_vs05/src/orxonox_scene.h	(revision 169)
+++ code/branches/main_reto_vs05/src/orxonox_scene.h	(revision 169)
@@ -0,0 +1,70 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software: you can redistribute it and/or modify
+ *   it under the terms of the GNU General Public License as published by
+ *   the Free Software Foundation, either version 3 of the License, or
+ *   (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ *
+ *
+ *   Author:
+ *      Reto Grieder
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+
+#ifndef ORXONOX_SCENE_H
+#define ORXONOX_SCENE_H
+
+#include "OgrePrerequisites.h"
+
+#include "orxonox_prerequisites.h"
+
+
+namespace orxonox {
+
+  class OrxonoxScene
+  {
+  public:
+    OrxonoxScene(Ogre::SceneManager*);
+
+	  virtual ~OrxonoxScene();
+
+	  virtual bool initialise();
+
+	  virtual bool tick(unsigned long, Ogre::Real);
+
+  protected:
+	  /// method where you can perform resource group loading
+	  virtual void loadResources();
+
+	  /// Define what is in the scene
+	  virtual void createScene();
+
+  protected:
+	  Ogre::SceneManager* sceneMgr_;
+
+	  //specific variables for test purposes
+	  Ogre::Light        *light_;
+	  Ogre::SceneNode    *lightNode_;
+	  Ogre::BillboardSet *bbs_;
+	  Ogre::Real distance_;
+    Ogre::Real radius_;
+  };
+
+}
+
+#endif /* ORXONOX_SCENE_H */
Index: code/branches/main_reto_vs05/src/orxonox_ship.cc
===================================================================
--- code/branches/main_reto_vs05/src/orxonox_ship.cc	(revision 161)
+++ code/branches/main_reto_vs05/src/orxonox_ship.cc	(revision 169)
@@ -35,6 +35,8 @@
 
 #include "orxonox_ship.h"
-
-namespace Orxonox {
+#include "weapon_manager.h"
+
+
+namespace orxonox {
   using namespace Ogre;
 
@@ -52,6 +54,4 @@
 
 
-
-
   /**
   * Standard constructor, that only initalizes a few variables. Some of them
@@ -99,4 +99,8 @@
 	  fishNode->attachObject(shipEntity_);
 	  fishNode->setScale(Vector3(10, 10, 10));
+
+    // initialise weapon(s)
+    SceneNode *mainWeaponNode = rootNode_->createChildSceneNode("mainWeaponNode");
+    mainWeapon_ = new WeaponManager(sceneMgr_, mainWeaponNode, 1);
 
 	  return true;
Index: code/branches/main_reto_vs05/src/orxonox_ship.h
===================================================================
--- code/branches/main_reto_vs05/src/orxonox_ship.h	(revision 169)
+++ code/branches/main_reto_vs05/src/orxonox_ship.h	(revision 169)
@@ -0,0 +1,78 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software: you can redistribute it and/or modify
+ *   it under the terms of the GNU General Public License as published by
+ *   the Free Software Foundation, either version 3 of the License, or
+ *   (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ *
+ *
+ *   Author:
+ *      Reto Grieder
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+
+#ifndef ORXONOX_SHIP_H
+#define ORXONOX_SHIP_H
+
+#include "OgrePrerequisites.h"
+
+#include "orxonox_prerequisites.h"
+
+
+namespace orxonox {
+
+  class OrxonoxShip
+  {
+  public:
+	  OrxonoxShip(Ogre::SceneManager*, Ogre::SceneNode*);
+	  virtual ~OrxonoxShip();
+
+	  virtual bool initialise();
+
+	  void setMainThrust(const Ogre::Real);
+	  void setSideThrust(const Ogre::Real);
+    void setYThrust(const Ogre::Real);
+	  void turnUpAndDown(const Ogre::Radian&);
+	  void turnLeftAndRight(const Ogre::Radian&);
+
+    Ogre::SceneNode* getRootNode();
+    Ogre::Vector3 getSpeed();
+
+	  Bullet* fire();
+
+	  bool tick(unsigned long, Ogre::Real);
+
+  protected:
+
+  protected:
+	  Ogre::SceneManager *sceneMgr_;
+	  Ogre::SceneNode *rootNode_;
+	  Ogre::Entity *shipEntity_;
+
+	  Ogre::Vector3 currentSpeed_;  // relative to space
+	  Ogre::Vector3 currentThrust_; // relative to the ship
+    Ogre::Real baseThrust_;
+	  int objectCounter_;
+	  Ogre::Vector3 bulletSpeed_;
+
+    WeaponManager *mainWeapon_;
+  };
+
+}
+
+#endif /* ORXONOX_SHIP_H */
Index: code/branches/main_reto_vs05/src/run_manager.cc
===================================================================
--- code/branches/main_reto_vs05/src/run_manager.cc	(revision 161)
+++ code/branches/main_reto_vs05/src/run_manager.cc	(revision 169)
@@ -25,17 +25,4 @@
 */
 
-
-/**
-* RunManager is the basic control object during the game.
-* 
-* The RunManger class is designed to actually "run" the main part of the
-* game. The Idea is, that you could derive from the RunManager in order
-* to distinguish between a first person shooter or a space craft shooter.
-* RunManager loads and initialises everything in the scene (like the ship,
-* the enemies in the scene, any scripts, the physics, window events,
-* environment, HUD, etc.).
-* It also captures any input from keyboard, mous, joystick (optional) or
-* Ogre (window events).
-*/
 
 #include "Ogre.h"
@@ -69,6 +56,20 @@
 #include "run_manager.h"
 
-namespace Orxonox {
+namespace orxonox {
   using namespace Ogre;
+
+  /**
+  * RunManager is the basic control object during the game.
+  * 
+  * The RunManger class is designed to actually "run" the main part of the
+  * game. The Idea is, that you could derive from the RunManager in order
+  * to distinguish between a first person shooter or a space craft shooter.
+  * RunManager loads and initialises everything in the scene (like the ship,
+  * the enemies in the scene, any scripts, the physics, window events,
+  * environment, HUD, etc.).
+  * It also captures any input from keyboard, mous, joystick (optional) or
+  * Ogre (window events).
+  */
+
 
   /**
@@ -240,7 +241,7 @@
     for (int i = 0; i < bulletsIndex_; i++)
     {
-      bullets_[i]->mNode->translate(bullets_[i]->mSpeed*deltaTime);
-      bullets_[i]->mNode->yaw(Degree(deltaTime*100));
-      bullets_[i]->mNode->roll(Degree(deltaTime*300));
+      bullets_[i]->node_->translate(bullets_[i]->speed_*deltaTime);
+      bullets_[i]->node_->yaw(Degree(deltaTime*100));
+      bullets_[i]->node_->roll(Degree(deltaTime*300));
     }
 
Index: code/branches/main_reto_vs05/src/run_manager.h
===================================================================
--- code/branches/main_reto_vs05/src/run_manager.h	(revision 169)
+++ code/branches/main_reto_vs05/src/run_manager.h	(revision 169)
@@ -0,0 +1,122 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software: you can redistribute it and/or modify
+ *   it under the terms of the GNU General Public License as published by
+ *   the Free Software Foundation, either version 3 of the License, or
+ *   (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ *
+ *
+ *   Author:
+ *      Reto Grieder
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+
+#ifndef RUN_MANAGER_H
+#define RUN_MANAGER_H
+
+#include "OgrePrerequisites.h"
+#include "OgreWindowEventUtilities.h"
+#include "OgreTextureManager.h"
+
+#include <OIS/OISPrereqs.h>
+
+#include "orxonox_prerequisites.h"
+
+
+namespace orxonox {
+
+  // let the class inherit from WindowEventListener in order for the RunMgr
+  // to act as the central point of all the calcuations in Orxonox
+  class RunManager : Ogre::WindowEventListener
+  {
+  public:
+	  RunManager(OgreControl*);
+
+	  virtual ~RunManager();
+
+    virtual bool tick(unsigned long, Ogre::Real);
+
+  protected:
+	  virtual void createCamera(void);
+
+	  virtual void createViewports(void);
+
+
+	  /** EVENT HANDLING **/
+
+	  //Adjust mouse clipping area
+	  virtual void windowResized(Ogre::RenderWindow*);
+
+	  //Unattach OIS before window shutdown (very important under Linux)
+	  virtual void windowClosed(Ogre::RenderWindow*);
+
+
+	  /** INPUT PROCESSING **/
+	  virtual bool processUnbufferedKeyInput();
+
+	  virtual bool processUnbufferedMouseInput();
+
+
+	  /** OUTPUT **/
+
+	  virtual void updateStats(void);
+
+	  virtual void showDebugOverlay(bool);
+
+  protected:
+	  Ogre::SceneManager *sceneMgr_;
+	  Ogre::RenderWindow *window_;
+	  Ogre::Camera       *camera_;
+	  OgreControl  *ogre_;
+	  OrxonoxScene *backgroundScene_;
+	  OrxonoxShip  *playerShip_;
+
+	  bool statsOn_;
+	  std::string debugText_;
+
+	  unsigned int screenShotCounter_;
+	  // just to stop toggles flipping too fast
+	  Ogre::Real timeUntilNextToggle_;
+	  bool leftButtonDown_;
+	  Ogre::TextureFilterOptions filtering_;
+	  int aniso_;
+
+	  int sceneDetailIndex_;
+	  Ogre::Overlay* debugOverlay_;
+
+	  //OIS Input devices
+	  OIS::InputManager* inputManager_;
+	  OIS::Mouse*    mouse_;
+	  OIS::Keyboard* keyboard_;
+	  OIS::JoyStick* joystick_;
+
+    const Ogre::Real mouseSensitivity_;
+
+    // Bullet array
+	  Bullet **bullets_;
+	  int bulletsSize_;
+	  int bulletsIndex_;
+
+	  // previously elapsed render time
+	  unsigned long totalTime_;
+
+  };
+
+}
+
+#endif /* RUN_MANAGER_H */
Index: code/branches/main_reto_vs05/src/weapon.h
===================================================================
--- code/branches/main_reto_vs05/src/weapon.h	(revision 169)
+++ code/branches/main_reto_vs05/src/weapon.h	(revision 169)
@@ -0,0 +1,53 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software: you can redistribute it and/or modify
+ *   it under the terms of the GNU General Public License as published by
+ *   the Free Software Foundation, either version 3 of the License, or
+ *   (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ *
+ *
+ *   Author:
+ *      Reto Grieder
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+
+#ifndef WEAPON_H
+#define WEAPON_H
+
+#include "OgreString.h"
+
+#include "orxonox_prerequisites.h"
+
+namespace orxonox {
+
+  class Weapon
+  {
+  public:
+    Weapon(const Ogre::String &name, int firePower, int firingRate)
+          : name_(name), firePower_(firePower), firingRate_(firingRate) { }
+    virtual ~Weapon() { }
+
+  public:
+    Ogre::String name_;
+    int firePower_;
+    int firingRate_;
+  };
+
+}
+
+#endif /* WEAPON_H */
Index: code/branches/main_reto_vs05/src/weapon_manager.cc
===================================================================
--- code/branches/main_reto_vs05/src/weapon_manager.cc	(revision 161)
+++ code/branches/main_reto_vs05/src/weapon_manager.cc	(revision 169)
@@ -28,13 +28,18 @@
 #include "OgreSceneManager.h"
 
+#include "weapon.h"
 #include "weapon_manager.h"
 
 
-namespace Orxonox {
+namespace orxonox {
   using namespace Ogre;
 
-  WeaponManager::WeaponManager(SceneManager *mSceneMgr)
+  Weapon** WeaponManager::weaponList_s = NULL;
+
+  WeaponManager::WeaponManager(SceneManager *sceneMgr, SceneNode *node,
+        int slotSize)
+        : sceneMgr_(sceneMgr), node_(node), slotSize_(slotSize), slotIndex_(0)
   {
-  	
+  	slots_ = new Weapon*[slotSize];
   }
 
@@ -42,4 +47,34 @@
   WeaponManager::~WeaponManager()
   {
+    if (slots_)
+      delete slots_;
+  }
+
+
+  bool WeaponManager::addWeapon(const Ogre::String &name)
+  {
+    if (name == weaponList_s[0]->name_)
+    {
+      // this is ugly, but for the time being, it has to fit.
+      slots_[slotIndex_++] = weaponList_s[0];
+      return true;
+    }
+    else
+      return false;
+  }
+
+
+  // static
+  bool WeaponManager::loadWeapons()
+  {
+    weaponList_s[0] = new Weapon("Barrel Gun", 10, 2);
+    return true;
+  }
+
+
+  // static
+  void WeaponManager::destroyWeapons()
+  {
+    delete weaponList_s[0];
   }
 
Index: code/branches/main_reto_vs05/src/weapon_manager.h
===================================================================
--- code/branches/main_reto_vs05/src/weapon_manager.h	(revision 169)
+++ code/branches/main_reto_vs05/src/weapon_manager.h	(revision 169)
@@ -0,0 +1,65 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software: you can redistribute it and/or modify
+ *   it under the terms of the GNU General Public License as published by
+ *   the Free Software Foundation, either version 3 of the License, or
+ *   (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ *
+ *
+ *   Author:
+ *      Reto Grieder
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+
+#ifndef WEAPON_MANAGER_H
+#define WEAPON_MANAGER_H
+
+#include "OgrePrerequisites.h"
+
+#include "orxonox_prerequisites.h"
+
+
+namespace orxonox {
+
+  class WeaponManager
+  {
+  public:
+    WeaponManager(Ogre::SceneManager*, Ogre::SceneNode*, int);
+	  virtual ~WeaponManager();
+
+    bool addWeapon(const Ogre::String&);
+
+    bool static loadWeapons();
+
+    void static destroyWeapons();
+
+  protected:
+    Ogre::SceneManager *sceneMgr_;
+    Ogre::SceneNode *node_;
+
+    Weapon **slots_;
+    int slotSize_;
+    int slotIndex_;
+
+    static Weapon **weaponList_s;
+
+  };
+
+}
+
+#endif /* WEAPON_MANAGER_H */